# Poco

# class DigestEngine

Library: Foundation
Package: Crypt
Header: Poco/DigestEngine.h

## Description

This class is an abstract base class for all classes implementing a message digest algorithm, like MD5Engine and SHA1Engine. Call update() repeatedly with data to compute the digest from. When done, call digest() to obtain the message digest.

## Inheritance

Known Derived Classes: Poco::Crypto::RSADigestEngine, HMACEngine, MD2Engine, MD4Engine, MD5Engine, SHA1Engine

## Member Summary

Member Functions: digest, digestLength, digestToHex, reset, update, updateImpl

## Types

### Digest

typedef std::vector < unsigned char > Digest;

## Constructors

### DigestEngine

DigestEngine();

## Destructor

### ~DigestEngine

virtual ~DigestEngine();

## Member Functions

### digest

virtual const Digest & digest() = 0;

Finishes the computation of the digest and returns the message digest. Resets the engine and can thus only be called once for every digest. The returned reference is valid until the next time digest() is called, or the engine object is destroyed.

### digestLength

virtual unsigned digestLength() const = 0;

Returns the length of the digest in bytes.

### digestToHex

static std::string digestToHex(
const Digest & bytes
);

Converts a message digest into a string of hexadecimal numbers.

### reset

virtual void reset() = 0;

Resets the engine so that a new digest can be computed.

### update

void update(
const void * data,
unsigned length
);

### update

void update(
char data
);

### update

void update(
const std::string & data
);

Updates the digest with the given data.

### updateImpl

virtual void updateImpl(
const void * data,
unsigned length
) = 0;

Updates the digest with the given data. Must be implemented by subclasses.